source: Daodan/MinGW/msys/1.0/bin/xzfgrep@ 1080

Last change on this file since 1080 was 1046, checked in by alloc, 8 years ago

Daodan: Added Windows MinGW and build batch file

File size: 5.2 KB
Line 
1#!/bin/sh
2
3# xzgrep -- a wrapper around a grep program that decompresses files as needed
4# Adapted from a version sent by Charles Levert <charles@comm.polymtl.ca>
5
6# Copyright (C) 1998, 2001, 2002, 2006, 2007 Free Software Foundation
7# Copyright (C) 1993 Jean-loup Gailly
8
9# Modified for XZ Utils by Andrew Dudman and Lasse Collin.
10
11# This program is free software; you can redistribute it and/or modify
12# it under the terms of the GNU General Public License as published by
13# the Free Software Foundation; either version 2 of the License, or
14# (at your option) any later version.
15
16# This program is distributed in the hope that it will be useful,
17# but WITHOUT ANY WARRANTY; without even the implied warranty of
18# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
19# GNU General Public License for more details.
20
21#SET_PATH - This line is a placeholder to ease patching this script.
22
23# Instead of unsetting XZ_OPT, just make sure that xz will use file format
24# autodetection. This way memory usage limit and thread limit can be
25# specified via XZ_OPT. With gzip and bzip2 it's OK to just unset the
26# environment variables.
27xz='xz --format=auto'
28unset GZIP BZIP BZIP2
29
30case ${0##*/} in
31 *egrep*) prog=xzegrep; grep=${GREP:-egrep};;
32 *fgrep*) prog=xzfgrep; grep=${GREP:-fgrep};;
33 *) prog=xzgrep; grep=${GREP:-grep};;
34esac
35
36version="$prog (XZ Utils) 5.0.3"
37
38usage="Usage: ${0##*/} [OPTION]... [-e] PATTERN [FILE]...
39Look for instances of PATTERN in the input FILEs, using their
40uncompressed contents if they are compressed.
41
42OPTIONs are the same as for '$grep'.
43
44Report bugs to <lasse.collin@tukaani.org>."
45
46# sed script to escape all ' for the shell, and then (to handle trailing
47# newlines correctly) turn trailing X on last line into '.
48escape='
49 s/'\''/'\''\\'\'''\''/g
50 $s/X$/'\''/
51'
52operands=
53have_pat=0
54files_with_matches=0
55files_without_matches=0
56no_filename=0
57with_filename=0
58
59while test $# -ne 0; do
60 option=$1
61 shift
62 optarg=
63
64 case $option in
65 (-[0123456789abcdhHiIKLlnoqrRsTuUvVwxyzZ]?*)
66 arg2=-\'$(expr "X${option}X" : 'X-.[0-9]*\(.*\)' | sed "$escape")
67 eval "set -- $arg2 "'${1+"$@"}'
68 option=$(expr "X$option" : 'X\(-.[0-9]*\)');;
69 (--binary-*=* | --[lm]a*=* | --reg*=*)
70 ;;
71 (-[ABCDefm] | --binary-* | --file | --[lm]a* | --reg*)
72 case ${1?"$option option requires an argument"} in
73 (*\'*)
74 optarg=" '"$(printf '%sX\n' "$1" | sed "$escape");;
75 (*)
76 optarg=" '$1'";;
77 esac
78 shift;;
79 (--)
80 break;;
81 (-?*)
82 ;;
83 (*)
84 case $option in
85 (*\'*)
86 operands="$operands '"$(printf '%sX\n' "$option" | sed "$escape");;
87 (*)
88 operands="$operands '$option'";;
89 esac
90 ${POSIXLY_CORRECT+break}
91 continue;;
92 esac
93
94 case $option in
95 (-[drRzZ] | --di* | --exc* | --inc* | --rec* | --nu*)
96 printf >&2 '%s: %s: Option not supported\n' "$0" "$option"
97 exit 2;;
98 (-[ef]* | --file | --file=* | --reg*)
99 have_pat=1;;
100 (--h | --he | --hel | --help)
101 echo "$usage" || exit 2
102 exit;;
103 (-H | --wi | --wit | --with | --with- | --with-f | --with-fi \
104 | --with-fil | --with-file | --with-filen | --with-filena | --with-filenam \
105 | --with-filename)
106 with_filename=1
107 continue;;
108 (-l | --files-with-*)
109 files_with_matches=1;;
110 (-L | --files-witho*)
111 files_without_matches=1;;
112 (--no-f*)
113 no_filename=1;;
114 (-V | --v | --ve | --ver | --vers | --versi | --versio | --version)
115 echo "$version" || exit 2
116 exit;;
117 esac
118
119 case $option in
120 (*\'?*)
121 option=\'$(expr "X${option}X" : 'X\(.*\)' | sed "$escape");;
122 (*)
123 option="'$option'";;
124 esac
125
126 grep="$grep $option$optarg"
127done
128
129if test $files_with_matches -eq 1 || test $files_without_matches -eq 1; then
130 grep="$grep -q"
131fi
132
133eval "set -- $operands "'${1+"$@"}'
134
135if test $have_pat -eq 0; then
136 case ${1?"Missing pattern; try \`${0##*/} --help' for help"} in
137 (*\'*)
138 grep="$grep -- '"$(printf '%sX\n' "$1" | sed "$escape");;
139 (*)
140 grep="$grep -- '$1'";;
141 esac
142 shift
143fi
144
145if test $# -eq 0; then
146 set -- -
147fi
148
149exec 3>&1
150res=0
151
152for i; do
153 case $i in
154 *[-.][zZ] | *_z | *[-.]gz | *.t[ag]z) uncompress="gzip -cdfq";;
155 *[-.]bz2 | *[-.]tbz | *.tbz2) uncompress="bzip2 -cdfq";;
156 *) uncompress="$xz -cdfq";;
157 esac
158 # Fail if xz or grep (or sed) fails.
159 xz_status=$(
160 exec 5>&1
161 ($uncompress -- "$i" 5>&-; echo $? >&5) 3>&- |
162 if test $files_with_matches -eq 1; then
163 eval "$grep" && { printf '%s\n' "$i" || exit 2; }
164 elif test $files_without_matches -eq 1; then
165 eval "$grep" || {
166 r=$?
167 if test $r -eq 1; then
168 printf '%s\n' "$i" || r=2
169 fi
170 exit $r
171 }
172 elif test $with_filename -eq 0 &&
173 { test $# -eq 1 || test $no_filename -eq 1; }; then
174 eval "$grep"
175 else
176 case $i in
177 (*'
178'* | *'&'* | *'\'* | *'|'*)
179 i=$(printf '%s\n' "$i" |
180 sed '
181 $!N
182 $s/[&\|]/\\&/g
183 $s/\n/\\n/g
184 ');;
185 esac
186 sed_script="s|^|$i:|"
187
188 # Fail if grep or sed fails.
189 r=$(
190 exec 4>&1
191 (eval "$grep" 4>&-; echo $? >&4) 3>&- | sed "$sed_script" >&3 4>&-
192 ) || r=2
193 exit $r
194 fi >&3 5>&-
195 )
196 r=$?
197 test "$xz_status" -eq 0 || test "$xz_status" -eq 2 || r=2
198 test $res -lt $r && res=$r
199done
200exit $res
Note: See TracBrowser for help on using the repository browser.